//+------------------------------------------------------------------+
//|                                                 Net_switcher.mq5 |
//|                                          Copyright 2015, Mikalas |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2015, Mikalas"
#property link      "http://www.mql5.com"
#property version   "1.00"
//
enum ENUM_INIT_DLL
{
  INIT_DLL_FAILED           = -1,
  INIT_DLL_SUCCES           = 0,
  INIT_DLL_WRONG_NAME_ONE   = 1,
  INIT_DLL_WRONG_NAME_TWO   = 2
};
enum ENUM_NET_STATE
{
  STATE_UNKNOWN             = -1,
  STATE_MAIN_SLAVE_DISABLED = 0,
  STATE_MAIN_SLAVE_ENABLED  = 1,
  STATE_MAIN_ENABLED        = 2,
  STATE_SLAVE_ENABLED       = 3
};
//
#import "netswitch.dll"
ENUM_INIT_DLL InitNetSwitch( const string NameOne, const string NameTwo );
ENUM_NET_STATE GetAdaptersState();
bool DisableMain();
bool EnableMain();
bool DisableSlave();
bool EnableSlave();
#import
//
input string	       p_expert     = "===   ===";                 // 
input uint            TimerTime    = 500;                                          //  ()
input string          AdaptNameOne = "Intel(R) 82579V Gigabit Network Connection"; //  
input string          AdaptNameTwo = "Realtek PCIe GBE Family Controller";         //  
input string          p_chart      = "===   ===";	                 // 
input color           ButtDown     = clrMagenta;                                   //  
input color           ButtUp       = clrMediumSeaGreen;                            //  
input uint            FontSize     = 10;                                           // 
input uint            StrSpace     = 13;                                           //  
input color           FontColor    = clrWhite;                                     // 
input ENUM_CHART_MODE Chart_mode   = CHART_CANDLES;                                // 
input ENUM_TIMEFRAMES TimeFrame    = PERIOD_CURRENT;                               // 
input color           Candle_bull  = clrGreen;                                     //  
input color           Candle_bear  = clrRed;                                       //  
input color           BackGround   = clrGray;                                      //  
input color           Color_last   = clrWhite;                                     //  
input color           Chart_up     = clrBlack;                                     //  
input color           Chart_down   = clrBlack;                                     //  
input color           Chart_grid   = clrDarkGray;                                  // 
//
bool           h_res;
bool           not_first;
bool           is_connected;
MqlDateTime    tick_time;
ENUM_NET_STATE net_state;
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
{
  not_first = false;
  
//--- DLL
  ENUM_INIT_DLL init_dll = InitNetSwitch( AdaptNameOne, AdaptNameTwo );
  
  switch( init_dll )
  {
    case INIT_DLL_FAILED: MessageBox( "  netswitch.dll!", "", MB_OK | MB_ICONHAND );
                          return( INIT_FAILED );
                          break;
                          
    case INIT_DLL_WRONG_NAME_ONE: MessageBox( "      " +
                                              AdaptNameOne + " .", "", MB_OK | MB_ICONHAND );
                                  return( INIT_FAILED );
                                  break;
                                  
    case INIT_DLL_WRONG_NAME_TWO: MessageBox( "      " +
                                              AdaptNameTwo + " .", "", MB_OK | MB_ICONHAND );
                                  return( INIT_FAILED );
                                  break;                                                    
  }
//---    
  net_state = GetAdaptersState();
//---  
  switch( net_state )
  {
    case STATE_UNKNOWN:             MessageBox( "  !", "", MB_OK | MB_ICONHAND );
                                    return( INIT_FAILED ); 
                                    break; 
                                    
    case STATE_MAIN_SLAVE_DISABLED: h_res = EnableMain(); // .  - 
                                    if ( h_res )
                                    {
                                      EnableSlave();
                                    } 
                                    break; 
                                    
    case STATE_MAIN_ENABLED:        EnableSlave(); //  
                                    break; 
                                    
    case STATE_SLAVE_ENABLED:       h_res = DisableSlave(); // ,  ,  ,   
                                    if ( h_res )
                                    {
                                      h_res = EnableMain();
                                      if ( h_res )
                                      {
                                        EnableSlave();
                                      }
                                    }
                                    break;
                                    
    case STATE_MAIN_SLAVE_ENABLED:  h_res = DisableSlave(); //       ,     
                                    if ( h_res )
                                    {
                                      EnableSlave();
                                    }
                                    break;                                                                                                 
  } 
//---
  //---
  if( !ObjectCreate( 0, "reset_button", OBJ_BUTTON, 0, 0, 0 ) )
  {
    MessageBox( " 'Reset'  !", "", MB_OK | MB_ICONHAND );
    return( INIT_FAILED );
  }
  else
  {
    ObjectSetInteger( 0, "reset_button", OBJPROP_CORNER, CORNER_RIGHT_LOWER );
    ObjectSetInteger( 0, "reset_button", OBJPROP_XDISTANCE, 40 );             
    ObjectSetInteger( 0, "reset_button", OBJPROP_YDISTANCE, 18 );
    ObjectSetInteger( 0, "reset_button", OBJPROP_XSIZE, 40 );
    ObjectSetInteger( 0, "reset_button", OBJPROP_YSIZE, 18 );
    ObjectSetInteger( 0, "reset_button", OBJPROP_BGCOLOR, ButtUp );
    ObjectSetInteger( 0, "reset_button", OBJPROP_STATE, false );
    ObjectSetString( 0, "reset_button", OBJPROP_TEXT, "Reset" );
  }
//---
  if( !ObjectCreate( 0, "info_label_1", OBJ_LABEL, 0, 0, 0 ) )
  {
    MessageBox( " 1  !", "", MB_OK | MB_ICONHAND );
    return( INIT_FAILED );
  }
  else
  {
    ObjectSetInteger( 0, "info_label_1", OBJPROP_CORNER, CORNER_LEFT_UPPER );
    ObjectSetInteger( 0, "info_label_1", OBJPROP_ANCHOR, ANCHOR_LEFT_UPPER );
    ObjectSetInteger( 0, "info_label_1", OBJPROP_XDISTANCE, 5 );             
    ObjectSetInteger( 0, "info_label_1", OBJPROP_YDISTANCE, 15 );
    ObjectSetInteger( 0, "info_label_1", OBJPROP_FONTSIZE, FontSize );
    ObjectSetInteger( 0, "info_label_1", OBJPROP_COLOR, FontColor );
    ObjectSetInteger( 0, "info_label_1",OBJPROP_BACK, false );
    ObjectSetString( 0, "info_label_1", OBJPROP_TEXT, "..." );
  }  
//--- Set chart in candles    
  if ( !ChartSetInteger(0, CHART_MODE, Chart_mode ) ) 
  {
    MessageBox( "   !", "", MB_OK | MB_ICONHAND );
    return( INIT_FAILED );
  }
//--- Set Time Frame H1
  if ( !ChartSetSymbolPeriod( 0, NULL, TimeFrame ) )
  {
    MessageBox( "   !", "", MB_OK | MB_ICONHAND );
    return( INIT_FAILED );
  }
//--- Set candles color
  if ( !ChartSetInteger( 0, CHART_COLOR_CANDLE_BULL, Candle_bull ) )
  {
    MessageBox( "    !", "", MB_OK | MB_ICONHAND );
    return( INIT_FAILED );
  }
//---      
  if ( !ChartSetInteger( 0, CHART_COLOR_CANDLE_BEAR, Candle_bear ) )
  {
    MessageBox( "    !", "", MB_OK | MB_ICONHAND );
    return( INIT_FAILED );
  } 
//--- Set fon color
  if ( !ChartSetInteger( 0, CHART_COLOR_BACKGROUND, BackGround ) )
  {
    MessageBox( "   !", "", MB_OK | MB_ICONHAND );
    return( INIT_FAILED );
  }
//--- Set hide line bid
  if ( !ChartSetInteger( 0, CHART_SHOW_BID_LINE, false ) )
  {
    MessageBox( "   BID!", "", MB_OK | MB_ICONHAND );
    return( INIT_FAILED );
  }   
//--- Set show line last 
  if ( !ChartSetInteger(0, CHART_SHOW_LAST_LINE, true ) )
  {
    MessageBox( "    !", "", MB_OK | MB_ICONHAND );
    return( INIT_FAILED );
  }      
//--- Set line bid color
  if ( !ChartSetInteger(0, CHART_COLOR_LAST, Color_last ) )
  {
    MessageBox( "     !", "", MB_OK | MB_ICONHAND );
    return( INIT_FAILED );
  }
//--- Set color bid up
  if ( !ChartSetInteger( 0, CHART_COLOR_CHART_UP, Chart_up ) )
  {
    MessageBox( "    !", "", MB_OK | MB_ICONHAND );
    return( INIT_FAILED );
  }
//--- Set color bid up
  if ( !ChartSetInteger( 0, CHART_COLOR_CHART_DOWN, Chart_down ) )
  {
    MessageBox( "    !", "", MB_OK | MB_ICONHAND );
    return( INIT_FAILED );
  }
//--- Color grid
  if ( !ChartSetInteger( 0, CHART_COLOR_GRID, Chart_grid ) )
  {
    MessageBox( "   !", "", MB_OK | MB_ICONHAND );
    return( INIT_FAILED );
  }    

//---     
  if ( TerminalInfoInteger( TERMINAL_CONNECTED ) )
  {
    is_connected = true;
  }
  else
  {
    is_connected = false;
  }
  ObjectSetString( 0, "info_label_1", OBJPROP_TEXT, "   ." );
  ChartRedraw();
//---  
  if ( !EventSetMillisecondTimer( TimerTime ) )
  {
    MessageBox( "  !", "", MB_OK | MB_ICONHAND );
    return( INIT_FAILED );
  }  
  return( INIT_SUCCEEDED );
}
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit( const int reason )
{
//---  
  EventKillTimer();
//---
  ObjectDelete( 0, "reset_button" ); 
  ObjectDelete( 0, "info_label_1" );
}
//+------------------------------------------------------------------+
//| Expert Switch To Main adapter function                           |
//+------------------------------------------------------------------+
void SwitchToMain( const ENUM_NET_STATE a_state )
{
  switch( a_state )
  {
      case STATE_UNKNOWN:              
      case STATE_MAIN_SLAVE_DISABLED: h_res = EnableMain();
                                      if ( h_res )
                                      {
                                        EnableSlave();
                                      }
                                      break;
                                        
      case STATE_MAIN_SLAVE_ENABLED:  h_res = DisableSlave();
                                      if ( h_res )
                                      {
                                        EnableSlave();
                                      }
                                      break;
                                        
      case STATE_MAIN_ENABLED:        EnableSlave();
                                      break;
                                        
      case STATE_SLAVE_ENABLED:       h_res = DisableSlave();
                                      if ( h_res )
                                      {
                                        h_res = EnableMain();
                                        if ( h_res )
                                        {
                                          EnableSlave();
                                        }
                                      }
                                      break;
  }  
}
//+------------------------------------------------------------------+
//| Expert timer function                                            |
//+------------------------------------------------------------------+
void OnTimer()
{
  TimeTradeServer( tick_time );
//---  
  if ( !TerminalInfoInteger( TERMINAL_CONNECTED ) )
  {
    if ( !not_first )
    {
      not_first = true;
      is_connected = false;
      Print( "OnTimer:  !" );
      SendMail( "Lost connection", "  " + string( tick_time.hour ) +
                ":" + string( tick_time.min ) + ":" + string( tick_time.sec ) );
//---
      net_state = GetAdaptersState();
//---      
      switch( net_state )     //  
      {
        case STATE_UNKNOWN:              
        case STATE_MAIN_SLAVE_DISABLED: h_res = EnableSlave();
                                        if ( h_res )
                                        {
                                          EnableMain();
                                        }
                                        break;
                                        
        case STATE_MAIN_SLAVE_ENABLED:  h_res = DisableMain();
                                        if ( h_res )
                                        {
                                          EnableMain();
                                        }
                                        break;
                                        
        case STATE_MAIN_ENABLED:        h_res = DisableMain();
                                        if ( h_res )
                                        {
                                          h_res = EnableSlave();
                                          if ( h_res )
                                          {
                                            EnableMain();
                                          }
                                        }
                                        break;
                                        
        case STATE_SLAVE_ENABLED:       EnableMain();
                                        break;                                
      }          
    }
  }
  else
  {                        // 
    if ( !is_connected )
    {
      not_first = false;
      is_connected = true;
      Print( "OnTimer:  !" );
      ObjectSetString( 0, "info_label_1", OBJPROP_TEXT, "   ." );
      ChartRedraw();                 
    }
  }  
}
//+------------------------------------------------------------------+
//| Expert Chart event function                                      |
//+------------------------------------------------------------------+
void OnChartEvent( const int id, const long& lparam, const double& dparam, const string& sparam )
{
  long b_state;
  
  if ( id == CHARTEVENT_OBJECT_CLICK )
  {
    if ( sparam == "reset_button" )
    {
      if ( ObjectGetInteger( 0, "reset_button", OBJPROP_STATE, 0, b_state ) )
      {
        if ( b_state == 1 )
        {
          ObjectSetInteger( 0, "reset_button", OBJPROP_BGCOLOR, ButtDown );
          ObjectSetString( 0, "reset_button", OBJPROP_TEXT, "Reset" );
          ChartRedraw();
//---     
          net_state = GetAdaptersState();
          SwitchToMain( net_state );  
          ObjectSetString( 0, "info_label_1", OBJPROP_TEXT, "   ." );   
          ObjectSetInteger( 0, "reset_button", OBJPROP_STATE, false ); 
          ObjectSetInteger( 0, "reset_button", OBJPROP_BGCOLOR, ButtUp );
          ObjectSetString( 0, "reset_button", OBJPROP_TEXT, "Reset" );
          ChartRedraw();     
        }
      }
    }
  }
}    
//+------------------------------------------------------------------+
//| The END                                                          |
//+------------------------------------------------------------------+

      