//+------------------------------------------------------------------+
//|                                                    netswitch.dll |
//|                                          Copyright 2015, Mikalas |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
library netswitch;

uses
  Winapi.Windows, System.SysUtils, Winapi.ActiveX, System.Win.ComObj,
  Winapi.UrlMon, System.Variants;

const
  wbemFlagForwardOnly = $00000020;
//---   DLL
  INIT_DLL_FAILED         = -1;
  INIT_DLL_SUCCES         = 0;
  INIT_DLL_WRONG_NAME_ONE = 1;
  INIT_DLL_WRONG_NAME_TWO = 2;
//---   
  STATE_UNKNOWN             = -1;
  STATE_MAIN_SLAVE_DISABLED = 0;
  STATE_MAIN_SLAVE_ENABLED  = 1;
  STATE_MAIN_ENABLED        = 2;
  STATE_SLAVE_ENABLED       = 3;

var
  MainName, SlaveName: string;

function GetAdapter( aName: string; ip_enabled: boolean ): boolean;
var
  oBindObj: IDispatch;
  oNetAdapters, oNetAdapter,
  odnsAddr, oWMIService: OleVariant;
  i, iValue: longword;
  oEnum: IEnumvariant;
  oCtx: IBindCtx;
  oMk: IMoniker;
  sFileObj: WideString;
  a_str: string;
  k: integer;
begin
  Result:= false;
//--- ActiveX
  CoInitialize( nil );
  try
    sFileObj:= 'winmgmts:\\.\root\cimv2';
//---
    OleCheck( CreateBindCtx( 0, oCtx ) );
    OleCheck( MkParseDisplayNameEx( oCtx,PWideChar( sFileObj ), i, oMk ) );
    OleCheck( oMk.BindToObject( oCtx,nil, IUnknown, oBindObj ) );
    oWMIService:= oBindObj;
    if ( ip_enabled ) then
      oNetAdapters:= oWMIService.ExecQuery( 'Select * from ' +
    'Win32_NetworkAdapterConfiguration ' +
    'where IPEnabled=TRUE') else
    oNetAdapters:= oWMIService.ExecQuery( 'Select * from ' +
    'Win32_NetworkAdapterConfiguration ' +
    'where IPEnabled=FALSE');
    oEnum:= IUnknown( oNetAdapters._NewEnum ) as IEnumVariant;
  //---
    while ( oEnum.Next( 1, oNetAdapter, iValue ) = 0 ) do
    begin
      try
        a_str:= oNetAdapter.Caption;
        k:= Pos( ']', a_str );
        if ( k > 0 ) then
        begin
           Delete( a_str, 1, k + 1) ;
          if ( aName = a_str ) then
          begin
            Result:= true;
            oNetAdapter:= Unassigned;
            break;
          end;
        end;
      except
      end;
      oNetAdapter:= Unassigned;
    end;
//---
    odnsAddr:= Unassigned;
    oNetAdapters:= Unassigned;
    oWMIService:= Unassigned;
  finally
    CoInitialize( Nil );
  end;
end;

function InitNetSwitch( main_name: PAnsiString; slave_name: PAnsiString ): Integer;  stdcall;
var
  is_main_found: boolean;
  is_slave_found: boolean;
begin
  Result:= INIT_DLL_FAILED;
  is_main_found:= false;
  is_slave_found:= false;
//---
  MainName:= string( main_name );
  SlaveName:= string( slave_name );
//---      
  if ( MainName <> '' ) then
    if ( GetAdapter( MainName, false ) ) then is_main_found:= true else
      if ( GetAdapter( MainName, true ) ) then is_main_found:= true;
//---      
  if ( SlaveName <> '' ) then
    if ( GetAdapter( SlaveName, false ) ) then is_slave_found:= true else
      if ( GetAdapter( SlaveName, true ) ) then is_slave_found:= true;
//--- 
  if ( is_main_found and is_slave_found ) then Result:= INIT_DLL_SUCCES else
    if ( is_main_found and ( not is_slave_found ) ) then Result:= INIT_DLL_WRONG_NAME_TWO else
      if ( ( not is_main_found ) and is_slave_found ) then Result:= INIT_DLL_WRONG_NAME_ONE;
end;


function GetAdaptersState(): Integer; stdcall;
begin
  Result:= STATE_UNKNOWN;
//---  
  if ( ( MainName <> '' ) and ( SlaveName <> '' ) ) then
  begin
    if ( GetAdapter( MainName, true ) ) then
    begin
      if ( GetAdapter( SlaveName, true ) ) then Result:= STATE_MAIN_SLAVE_ENABLED else
        Result:= STATE_MAIN_ENABLED;
    end else
    begin
      if ( GetAdapter( SlaveName, true ) ) then Result:= STATE_SLAVE_ENABLED else
        Result:= STATE_MAIN_SLAVE_DISABLED;
    end;
  end;
end;

function EnableDisableAdapter( a_name: string; disable_enable: boolean ): boolean;
var
 FSWbemLocator: OLEVariant;
 FWMIService: OLEVariant;
 FWbemObjectSet: OLEVariant;
 FWbemObject: OLEVariant;
 oEnum: IEnumvariant;
 iValue: LongWord;
 a_str: string;
 k: integer;
begin
  Result:= false;
//--- ActiveX
  CoInitialize( nil );
  try
    if ( a_name <> '' ) then
    begin
      FSWbemLocator:= CreateOleObject( 'WbemScripting.SWbemLocator' );
      FWMIService:= FSWbemLocator.ConnectServer('localhost', 'root\CIMV2', '', '' );
      if ( disable_enable ) then
        FWbemObjectSet:= FWMIService.ExecQuery('SELECT * FROM Win32_NetworkAdapter Where NetEnabled=False',
                                                     'WQL', wbemFlagForwardOnly ) else
      FWbemObjectSet:= FWMIService.ExecQuery('SELECT * FROM Win32_NetworkAdapter Where NetEnabled=True',
                                                     'WQL', wbemFlagForwardOnly );
      oEnum:= IUnknown(FWbemObjectSet._NewEnum) as IEnumVariant;
      while oEnum.Next(1, FWbemObject, iValue ) = 0 do
      begin
        a_str:= FWbemObject.Caption;
        k:= Pos( ']', a_str );
        if ( k > 0 ) then
        begin
          Delete( a_str, 1, k + 1 );
          if ( a_name = a_str ) then
          begin
            if ( disable_enable ) then
              FWbemObject.Enable() else
            FWbemObject.Disable();
            Result:= true;
          end;
        end;
        FWbemObject:= Unassigned;
      end;
    end;
  finally
    CoInitialize( nil );
  end;
end;

function DisableMain(): Boolean; stdcall;
begin
  Result:= EnableDisableAdapter( MainName, false );
end;

function EnableMain(): Boolean; stdcall;
begin
  Result:= EnableDisableAdapter( MainName, true );
end;

function DisableSlave(): Boolean; stdcall;
begin
  Result:= EnableDisableAdapter( SlaveName, false );
end;

function EnableSlave(): Boolean; stdcall;
begin
  Result:= EnableDisableAdapter( SlaveName, true );
end;

exports
  InitNetSwitch,
  GetAdaptersState,
  DisableMain,
  EnableMain,
  DisableSlave,
  EnableSlave;

begin

end.

